#!/bin/bash
set -e

SCRIPT_DIR=$(dirname $(realpath $0))
MODULE_NAME=uoa
VERSION=$(head -n 1 $SCRIPT_DIR/deb/version | tr -d '[:space:]')
BUILD_DIR=$SCRIPT_DIR/build
SRC_DIR=$SCRIPT_DIR
DEB_DIR=$SCRIPT_DIR/deb
PACKAGE_DIR=$BUILD_DIR/$MODULE_NAME-$VERSION

mkdir -p $PACKAGE_DIR/DEBIAN
mkdir -p $PACKAGE_DIR/usr/src/$MODULE_NAME-$VERSION

cp $SCRIPT_DIR/../../include/uoa.h $SCRIPT_DIR/
rsync -av --exclude='build' --exclude='deb' $SRC_DIR/ $PACKAGE_DIR/usr/src/$MODULE_NAME-$VERSION/
cp -r $DEB_DIR/DEBIAN/* $PACKAGE_DIR/DEBIAN/

sed -i "s/<VERSION>/$VERSION/" $PACKAGE_DIR/DEBIAN/control
sed -i "s/<VERSION>/$VERSION/" $PACKAGE_DIR/DEBIAN/postinst
sed -i "s/<VERSION>/$VERSION/" $PACKAGE_DIR/DEBIAN/postrm

chmod 755 $PACKAGE_DIR/DEBIAN/postinst
chmod 755 $PACKAGE_DIR/DEBIAN/postrm

dpkg-deb --build $PACKAGE_DIR

mv $PACKAGE_DIR.deb $SCRIPT_DIR/$MODULE_NAME-$VERSION.deb

rm -rf $BUILD_DIR
rm -f $SCRIPT_DIR/uoa.h

echo "Package $MODULE_NAME-$VERSION.deb created successfully."
